# Class VulkanComponentMapping

java.lang.Object
com.io7m.jcoronado.api.VulkanComponentMapping

All Implemented Interfaces:
  `VulkanComponentMappingType`

public final class VulkanComponentMapping extends Object implements VulkanComponentMappingType
A structure specifying a color component mapping.

See Also:
  - "VkComponentMapping"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanComponentMapping.Builder`
  Builds instances of type `VulkanComponentMapping`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanComponentSwizzle`
  `a()`
  `VulkanComponentSwizzle`
  `b()`
  `static VulkanComponentMapping.Builder`
  `builder()`
  Creates a builder for `VulkanComponentMapping`.
  `static VulkanComponentMapping`
  `copyOf(VulkanComponentMappingType instance)`
  Creates an immutable copy of a `VulkanComponentMappingType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanComponentMapping` that have equal attribute values.
  `VulkanComponentSwizzle`
  `g()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `r`, `g`, `b`, `a`.
  `static VulkanComponentMapping`
  `of(VulkanComponentSwizzle r, VulkanComponentSwizzle g, VulkanComponentSwizzle b, VulkanComponentSwizzle a)`
  Construct a new immutable `VulkanComponentMapping` instance.
  `VulkanComponentSwizzle`
  `r()`
  `String`
  `toString()`
  Prints the immutable value `VulkanComponentMapping` with attribute values.
  `final VulkanComponentMapping`
  `withA(VulkanComponentSwizzle value)`
  Copy the current immutable object by setting a value for the `a` attribute.
  `final VulkanComponentMapping`
  `withB(VulkanComponentSwizzle value)`
  Copy the current immutable object by setting a value for the `b` attribute.
  `final VulkanComponentMapping`
  `withG(VulkanComponentSwizzle value)`
  Copy the current immutable object by setting a value for the `g` attribute.
  `final VulkanComponentMapping`
  `withR(VulkanComponentSwizzle value)`
  Copy the current immutable object by setting a value for the `r` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### r

    public VulkanComponentSwizzle r()
    Specified by:
      `r` in interface `VulkanComponentMappingType`
    Returns:
      The component value placed in the R component of the output vector.

  - ### g

    public VulkanComponentSwizzle g()
    Specified by:
      `g` in interface `VulkanComponentMappingType`
    Returns:
      The component value placed in the G component of the output vector.

  - ### b

    public VulkanComponentSwizzle b()
    Specified by:
      `b` in interface `VulkanComponentMappingType`
    Returns:
      The component value placed in the G component of the output vector.

  - ### a

    public VulkanComponentSwizzle a()
    Specified by:
      `a` in interface `VulkanComponentMappingType`
    Returns:
      The component value placed in the A component of the output vector.

  - ### withR

    public final VulkanComponentMapping withR(VulkanComponentSwizzle value)
    Copy the current immutable object by setting a value for the `r` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r
    Returns:
      A modified copy of the `this` object

  - ### withG

    public final VulkanComponentMapping withG(VulkanComponentSwizzle value)
    Copy the current immutable object by setting a value for the `g` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for g
    Returns:
      A modified copy of the `this` object

  - ### withB

    public final VulkanComponentMapping withB(VulkanComponentSwizzle value)
    Copy the current immutable object by setting a value for the `b` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for b
    Returns:
      A modified copy of the `this` object

  - ### withA

    public final VulkanComponentMapping withA(VulkanComponentSwizzle value)
    Copy the current immutable object by setting a value for the `a` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for a
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanComponentMapping` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `r`, `g`, `b`, `a`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanComponentMapping` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanComponentMapping of(VulkanComponentSwizzle r, VulkanComponentSwizzle g, VulkanComponentSwizzle b, VulkanComponentSwizzle a)
    Construct a new immutable `VulkanComponentMapping` instance.
    Parameters:
      `r` - The value for the `r` attribute
      `g` - The value for the `g` attribute
      `b` - The value for the `b` attribute
      `a` - The value for the `a` attribute
    Returns:
      An immutable VulkanComponentMapping instance

  - ### copyOf

    public static VulkanComponentMapping copyOf(VulkanComponentMappingType instance)
    Creates an immutable copy of a `VulkanComponentMappingType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanComponentMapping instance

  - ### builder

    public static VulkanComponentMapping.Builder builder()
    Creates a builder for `VulkanComponentMapping`.

         VulkanComponentMapping.builder()
            .setR(com.io7m.jcoronado.api.VulkanComponentSwizzle) // required r
            .setG(com.io7m.jcoronado.api.VulkanComponentSwizzle) // required g
            .setB(com.io7m.jcoronado.api.VulkanComponentSwizzle) // required b
            .setA(com.io7m.jcoronado.api.VulkanComponentSwizzle) // required a
            .build();

    Returns:
      A new VulkanComponentMapping builder